<script>
	import FilterTop from "@/components/Filter/Top.svelte"
	import FilterAside from "@/components/Filter/Aside.svelte"
	import Card from "@/components/CarCard.svelte"
	import Loading from "@/components/loading.svelte"
	import NoResults from "@/components/NoResults.svelte"

	import { l } from "@/i18n"
	import { active } from "@/stores/filter"
	import { navigating, page } from "$app/stores"
	import { browser } from "$app/environment"

	import { update } from "@/helpers/lazyload"
  import { onMount, afterUpdate } from "svelte"

	export let data

	$: cars = data.cars
	let grid = null
	let wrapGrid

	onMount(async () => {
		update()
		if (browser) {
			wrapGrid = (await import("animate-css-grid")).wrapGrid
		}
	})
	afterUpdate(update)

	$: if (grid && wrapGrid && !import.meta.env.SSR) wrapGrid(grid, { easing: 'backOut', duration: 400 })
</script>

<svelte:head>
	<link rel=”canonical” href=”https://dcr.ae{$l(`cars${$page.params.slug ? "/" + $page.params.slug : ""}`)}”>
</svelte:head>

<FilterTop />
<div class="is-flex wrap">
	<div class="aside" class:expanded={$active}>
		<!-- svelte-ignore a11y-click-events-have-key-events -->
		<div class="background" on:click={() => active.set(false)}></div>
		<FilterAside />
	</div>
	<div class="body is-flex-grow-1">
		<Loading active={$navigating} />
		{#if cars && cars.length}
			<div bind:this={grid} class="cars" class:has-aside={$active}>
				{#each cars as car}
					<div class="item">
						<Card car={car} />
					</div>
				{/each}
			</div>
		{:else}
			<div class="no-results-wrap">
				<NoResults />
			</div>
		{/if}
	</div>
</div>

<!-- {#if cars}
{/if} -->

<style lang="scss">
	.body {
		position: relative;
	}
	.wrap {
		padding-bottom: 7.5rem;
	}
	.aside {
		overflow-x: clip;
		@include min_mobile {
			--width: 0;
			max-width: var(--width);
			min-width: var(--width);
			// background: $white;
			position: relative;
			z-index: 2;
			transition: 
				max-width .2s ease-in-out,
				min-width .2s ease-in-out,
				margin-right .2s ease-in-out;
			&.expanded {
				--width: 248px;
				margin-right: .5rem;
			}	
		}
		@include max_mobile {
			width: 100%;
			height: 100vh;
			position: fixed;
			top: 0;
			right: 100%;
			transition: right .2s ease-in-out;
			z-index: 9;
			.background {
				width: 100%;
				height: 100%;
				background: rgba(27, 26, 26, 0);
				position: absolute;
				top: 0;
				left: 0;
				transition: background .2s ease-in-out;
			}
			&.expanded {
				right: 0;
				.background {
					background: rgba(27, 26, 26, 0.7);
				}
			}
		}
	}
	.cars {
		overflow: hidden;

		@include min_mobile {
			display: grid;
			grid-gap: 0.5rem;
			grid-auto-rows: 1fr;
			grid-auto-flow: dense;
		}
		
		@include min_desktop {
			grid-template-columns: repeat(5, 1fr);
			&.has-aside {
				grid-template-columns: repeat(4, 1fr);
			}
		}

		@include desktop-only {
			grid-template-columns: repeat(4, 1fr);
			&.has-aside {
				grid-template-columns: repeat(3, 1fr);
			}
		}

		@include tablet-only {
			grid-template-columns: repeat(3, 33.33333%);
			&.has-aside {
				grid-template-columns: repeat(2, 50%);
			}
		}

		@include max_mobile {
			display: flex;
			align-items: flex-start;
			justify-content: flex-start;
			flex-wrap: wrap;
			width: 100%;
			.item {
				width: 100%;
			}
		}
	}
	.no-results-wrap {
		max-width: 313px;
		margin: 7.5rem auto 0;
	}
</style>